searchData={"items":[{"type":"module","title":"Dummy","doc":"Documentation for Dummy.","ref":"Dummy.html"},{"type":"function","title":"Dummy.apply_options/2","doc":"","ref":"Dummy.html#apply_options/2"},{"type":"macro","title":"Dummy.called/1","doc":"","ref":"Dummy.html#called/1"},{"type":"macro","title":"Dummy.dummy/4","doc":"Mocks methods of a single module. Mocked methods return their\nfirst argument by default and non-mocked methods are passed through.","ref":"Dummy.html#dummy/4"},{"type":"module","title":"Dummy.Functions","doc":"Provides functions that are hard to find/mock in the standard library.\nTests can instead mock these.","ref":"Dummy.Functions.html"},{"type":"function","title":"Dummy.Functions.five/5","doc":"","ref":"Dummy.Functions.html#five/5"},{"type":"module","title":"Dummy.Method","doc":"Handles replacing methods","ref":"Dummy.Method.html"},{"type":"function","title":"Dummy.Method.replace/2","doc":"Replaces a method with a mock, according to how the mock was defined:\n\"function\", \"function/N\", {\"function\", value}, {\"function/N\", value}\nor {\"function\", fn}\n\n\"function/ \" replaces a function with one that returns \"function/ \".\n\n\"function\" is a shorthand for \"function/1\"\n\n{\"function\", value} replaces the function with an anonymous, single-argument\nfunction that returns 'value'\n\n{\"function\", fn a, b, .. -> body end} replaces the original function with\nthe given one.","ref":"Dummy.Method.html#replace/2"},{"type":"extras","title":"Dummy","doc":"# Dummy\n\n[![Hex.pm](https://img.shields.io/hexpm/v/dummy.svg?style=for-the-badge)](https://hex.pm/packages/dummy)\n[![Hexdocs](https://img.shields.io/badge/docs-hexdocs-blueviolet.svg?style=for-the-badge)](https://hexdocs.pm/dummy)\n\nElixir mocking that makes sense. Dummy relies on meck and exposes a simple way\nto mock methods, thanks to a couple of assumptions:\n\n- passthrough is enabled\n- mocked methods return their arguments\n- it's easy to specify replacements","ref":"readme.html"},{"type":"extras","title":"Installing - Dummy","doc":"```elixir\n    {:dummy, \"~> 2.0\", only: :test}\n```","ref":"readme.html#installing"},{"type":"extras","title":"Usage - Dummy","doc":"```elixir\nuse ExUnit.Case\nimport Dummy\n\nalias MyApp.Module\n\n\ntest \"my test\" do\n    dummy OtherModule, [\"method\"] do\n        Module.call_to_other_module(\"arg1\")\n        assert called(OtherModule.method(\"arg1\"))\n    end\nend\n```\n\n#","ref":"readme.html#usage"},{"type":"extras","title":"Arities - Dummy","doc":"```elixir\ntest \"my test\" do\n    dummy OtherModule, [\"method/2\"] do\n        Module.call_to_other_module(\"arg1\", \"arg2\")\n        assert called(OtherModule.method(\"arg1\", \"arg2\"))\n    end\nend\n```\n\n#","ref":"readme.html#arities"},{"type":"extras","title":"Specifying a return value - Dummy","doc":"```elixir\ntest \"my test\" do\n    dummy OtherModule, [{\"method\", \"value\"}] do\n        assert OtherModule.method(\"anything\") == \"value\"\n    end\nend\n```\n\n#","ref":"readme.html#specifying-a-return-value"},{"type":"extras","title":"Specifying a return value and an arity - Dummy","doc":"```elixir\ntest \"my test\" do\n    dummy OtherModule, [{\"method/2\", \"value\"}] do\n        assert OtherModule.method(1, 2) == \"value\"\n    end\nend\n```\n\n#","ref":"readme.html#specifying-a-return-value-and-an-arity"},{"type":"extras","title":"Specifying a replacement function - Dummy","doc":"```elixir\ntest \"my test\" do\n    dummy OtherModule, [{\"method\", fn _x -> %{key: => \"value\"} end}] do\n        assert OtherModule.method(\"anything\") == %{key: => \"value\"}\n    end\nend\n```\n\n#","ref":"readme.html#specifying-a-replacement-function"},{"type":"extras","title":"Multiple replacements - Dummy","doc":"```elixir\ntest \"my test\" do\n    dummy OtherModule, [\"method\", \"other_method\"] do\n        Module.call_to_other_module(\"arg1\")\n        assert called(OtherModule.method(\"arg1\"))\n        assert called(OtherModule.other_method(\"other_arg\"))\n    end\nend\n```\n\n#","ref":"readme.html#multiple-replacements"},{"type":"extras","title":"Disabling passthrough - Dummy","doc":"```elixir\ntest \"my test\" do\n    dummy OtherModule, [\"method\"], passthrough: false do\n        Module.call_to_other_module(\"arg1\")\n        assert called(OtherModule.method(\"arg1\"))\n    end\nend\n```","ref":"readme.html#disabling-passthrough"}],"content_type":"text/markdown"}